<?php
function zing_ws_live_set_options() {
	global $zing_ws_options,$zing_ws_name,$zing_ws_shortname;
	global $db_prefix,$base_path,$base_url,$db_url;

	$zing_ws_name = "Zingiri Web Shop";
	$zing_ws_shortname = "zing_ws";
	$install_type = array("Yes","No");
	$zing_yn = array("Yes", "No");

	$zing_ws_options=array();

	//	if (get_option($zing_ws_shortname."_baseurl") && get_option($zing_ws_shortname."_accname")) {
	//$desc='To manage your shop, login to your <a href="'.get_option($zing_ws_shortname."_baseurl").get_option($zing_ws_shortname."_accname").' " target="_blank">Zingiri Web Shop Live</a> account.<br />&nbsp';
	//} else {
	$desc='1) If you haven\'t done so yet, start by signing up for a <a href="http://www.zingiri.com/portal/?ccce=cart&a=add&pid=102" target="_blank">free Zingiri Web Shop Live account</a>. After sign up you will receive an email with your account ID and login details.<br />';
	$desc.='2) Login to your account once to activate the web shop.<br />';
	$desc.='3) Fill in your account ID the field below and click "update".<br />';
	$zing_ws_options[] =
	array(  "name" => "Set up instructions",
    	        "type" => "heading",
				"desc" => $desc,
	);
	//}

	$zing_ws_options[]=array(  "name" => "Connection settings",
            "type" => "heading",
			"desc" => "This section manages the Web Shop connection settings.");

	$zing_ws_options[]=	array(	"name" => "Base URL",
		"desc" => "URL of the Zingiri Web Shop Live service. Normally this should be left to it's default value.",
		"id" => $zing_ws_shortname."_baseurl",
		"std" => 'http://live.zingiri.com/',
		"attr" => 'readonly="readonly"',
		"type" => "text");

	$zing_ws_options[]=	array(	"name" => "Account ID",
		"desc" => "After sign up you will receive your account, please enter it here. It's a string of letters and numbers.",
		"id" => $zing_ws_shortname."_accname",
		"std" => '',
		"type" => "text");

	if (get_option("zing_webshop_pages")) {
		$zing_ws_options[]=array(  "name" => "General settings",
            "type" => "heading",
			"desc" => "This section manages the Web Shop general settings.");

		global $wpdb;
		if ($ids=get_option("zing_webshop_pages")) {
			$ida=explode(",",$ids);
			foreach ($ida as $i) {
				$p = $wpdb->get_results( "SELECT post_title FROM ".$wpdb->prefix."posts WHERE post_status<>'trash' and id='".$i."'" );
				$zing_ws_options[]=array(	"name" => $p[0]->post_title." page",
			"desc" => "Display ".$p[0]->post_title." page in the menus.",
			"id" => $zing_ws_shortname."_show_menu_".$i,
			"std" => "Yes",
			"type" => "select",
			"options" => $zing_yn);
			}
		}
	}
	
	$zing_ws_options[]=array(  "name" => "Before you install",
            "type" => "heading",
			"desc" => '<div style="text-decoration:underline;display:inline;font-weight:bold">IMPORTANT:</div> Web Shop uses web services stored on Zingiri\'s servers. In doing so, personal data is collected and stored on our servers. 
					This data includes amongst others your admin email address as this is used, together with the account ID as a unique identifier for your account on Zingiri\'s servers.
					We have a very strict <a href="http://www.zingiri.com/privacy-policy/" target="_blank">privacy policy</a> as well as <a href="http://www.zingiri.com/terms/" target="_blank">terms & conditions</a> governing data stored on our servers.
					<div style="font-weight:bold;display:inline">By installing this plugin you accept these terms & conditions.</div>');

	/* still to be implemented
	 $zing_ws_options[]=	array(	"name" => "Single sign on",
		"desc" => "If selected, users logged in to your site are automatically signed in to the web shop.",
		"id" => $zing_ws_shortname."_sso",
		"std" => "y",
		"type" => "select",
		"options" => array("y" => "Yes","n" => "No"));
		*/

}

function zing_wslive_ws_admin() {

	global $zing_ws_name, $zing_ws_shortname, $zing_ws_options, $integrator;

	zing_ws_live_set_options();

	if (isset($_REQUEST['installed']) && $_REQUEST['installed']) echo '<div id="message" class="updated fade"><p><strong>'.$zing_ws_name.' settings updated.</strong></p></div>';
	?>
<div class="wrap">
	<form method="post">
	<?php if (ZING_CMS=='jl') echo '<input type="hidden" name="option" value="com_zingiriwebshop" />';?>
	<?php zing_options($zing_ws_options);?>
		<center class="submit">
			<input name="install" type="submit" value="Update" />
		</center>
		<input type="hidden" name="action" value="install" />
	</form>
	<?php if (zing_ws_active_install()) {
		echo '<hr />';
		echo '<h3>Migrate</h3>';
		echo '<p>';
		zing_ws_migrate();
		echo 'To migrate your curent local data, first download <a href="'.ZING_WSLIVE_UPLOADS_URL.get_option('zing_ws_dumpfile').'.zip">this file</a> to your computer and then upload it to your <a href="'.get_option('zing_ws_baseurl').get_option('zing_ws_accname').'/wp-admin/admin.php?page=migrate" target="_blank">Zingiri Live Admin Panel</a>.';
		echo '</p><br />';
	}
	?>
	<?php zing_wslive_admin_footer();?>
</div>
<?php
}

function zing_wslive_admin_footer() {
	?>
	<div style="clear:both"></div>
	<hr />
	<div style="margin-bottom:20px;text-align:center;">
		<a href="http://www.zingiri.com/portal/?ccce=downloads&action=displaycat&catid=6" target="_blank">Documentation</a> | <a href="http://forums.zingiri.com/forumdisplay.php?fid=78" target="_blank">Support Forums</a> | <a href="http://www.zingiri.com/support" target="_blank">Pro Support Options</a>
	</div>
	<div style="text-align:center">
		<image src="<?php echo plugins_url()?>/ws-live/live/images/logo.png" />
	</div>
<?php }